using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using MacGruber;
using UnityEngine;
using Random = UnityEngine.Random;
using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;

namespace CheesyFX
{
    public class SlapMe : MVRScript
    {
        public static SlapMe singleton;
        public static Atom atom;
        

        public static JSONStorableBool slapVocalsEnabled = new JSONStorableBool("Slap Vocal Reaction Enabled", false);
        // public static JSONStorableBool slapMoanEnabled = new JSONStorableBool("Slap Moans Enabled", true);
        // public static JSONStorableBool sexSlapMoanEnabled = new JSONStorableBool("Sex Slap Moans Enabled", true);
        public static JSONStorableBool isSlappingOthers = new JSONStorableBool("Slap Others Enabled", true);
        public static JSONStorableFloat slapVolume = new JSONStorableFloat("Slap Volume", 1f, 0f, 10f, false);
        public static JSONStorableFloat sexSlapVolume = new JSONStorableFloat("Sex Slap Volume", .8f, 0f, 10f, false);
        public static JSONStorableFloat sexSlapThreshold = new JSONStorableFloat("Sex Slap Threshold", .05f, 0f, .2f, false);
        public static JSONStorableFloat slapThreshold = new JSONStorableFloat("Slap Threshold", 1f, 0f, 2f, false);

        public static List<Atom> excludedAtoms = new List<Atom>();
        private JSONStorableString excludedInfo = new JSONStorableString("ignoreInfo", "");

        private JSONStorableStringChooser excludedChooser =
	        new JSONStorableStringChooser("atomChooser", null, "", "Select Atom");

        // public static JSONStorableStringChooser vammoanSlapVoice =
	       //  new JSONStorableStringChooser("vammoanSlapVoice", null, "Isabella", "VAMMoan Voice");

        private static float sexSlapIntensity;
        // private static float slapIntensity;
        AudioSource slapAS;
        private static AudioSource sexSlapAS;
        private static IEnumerator sexSlap;
        
        public static ClipLibrary slapLibrary;
        public static ClipLibrary sexSlapLibrary;
        public static ClipLibrary buttSlapLibrary;

        public static ReadMyLips readMyLips;
        
        public static string packageUid;
        
        public override void Init()
        {
            singleton = this;
            atom = containingAtom;
            packageUid = Utils.GetPackagePath(this);

            slapLibrary = new ClipLibrary("slaps");
            sexSlapLibrary = new ClipLibrary("sexslaps");
            buttSlapLibrary = new ClipLibrary("buttslaps");
            
            var slapsPath = packageUid + "Custom/Scripts/CheesyFX/BodyLanguage/audiobundles/slaps.audiobundle";
            AudioImporter.GetClipsFromAssetBundle(new List<ClipLibrary>{slapLibrary, sexSlapLibrary, buttSlapLibrary},
	            slapsPath);
            
            

            excludedChooser.choices = SuperController.singleton.GetAtomUIDs();
            SuperController.singleton.onAtomAddedHandlers += AddExclusionChoice;
            SuperController.singleton.onAtomUIDsChangedHandlers += SyncAtomNames;
            CreateUI();
        }

        private void CreateUI()
        {
	        slapVolume.CreateUI(script:this);
	        sexSlapVolume.CreateUI(script:this, rightSide:true);
	        // UIManager.SetupInfoOneLine(null, "Expressions", false, false, this);
	        // var textfield = CreateTextField(new JSONStorableString("", "Expressions"));
	        // textfield.height = 50f;
	        // textfield.UItext.alignment = TextAnchor.MiddleCenter;
	        
	        var button = CreateButton("Disable Touches with...");
	        button.button.onClick.AddListener(() => Exclude(excludedChooser.val, true));
	        button = CreateButton("Enable Touches with...");
	        button.button.onClick.AddListener(() => Exclude(excludedChooser.val, false));
	        excludedChooser.CreateUI(script: this, rightSide: true,chooserType:2);
	        button = CreateButton("Reset");
	        button.button.onClick.AddListener(ResetExcluded);
	        var textfield = CreateTextField(excludedInfo, true);
	        textfield.height = 400f;
	        // textfield.UItext.alignment = TextAnchor.;
        }
        
        public static void Slap(TouchZone touchZone, Collision collision)
		{
			
			ContactPoint contactPoint = collision.contacts[0];
			Vector3 velocity = collision.relativeVelocity;
			float intensity = Vector3.Dot(velocity, contactPoint.normal);
			// if(intensity < .01f) return;
			touchZone.slapAudioObject.transform.position = contactPoint.point;
			AudioSource audioSource = touchZone.slapAudioSource;
			Atom collidingAtom = collision.rigidbody.GetAtom();
			string collidingRegion = collision.rigidbody.GetRegion();
			bool selfSlap = collidingAtom == atom;
			bool slappedByPerson =
				(collidingAtom.type == "Person" &&
				 (collidingRegion.Contains("Hand") || collidingRegion.Contains("Arm"))) ||
				collidingAtom.type == "Dildo" || collidingAtom.type == "Paddle" || collidingAtom.type == "Capsule";
			bool collidingAtomIsPenetrating = FillMeUp.penetratingAtoms.Values.ToList().Contains(collidingAtom);
			if (collidingAtomIsPenetrating &&
			    (collidingRegion == "Penis" || collidingRegion == "DildoPenis")) return;
			
			if(
				collidingAtomIsPenetrating
				&& intensity > sexSlapThreshold.val
				&& collidingRegion != null
				&& (collidingRegion == "Pelvis" || collidingRegion == "Abdomen"  || collidingRegion.Contains("Thigh") || collidingRegion == "Testes" || collidingRegion == "DildoSack")
				&& (touchZone.name.Contains("Thigh") || touchZone.name.Contains("Glutes") || touchZone.name == "Labia" || touchZone.name == "Anus" || touchZone.name == "Vagina")
				// && !touchZone.collisionListener.stuffColliding.Any(x => x.GetBodyRegion() == collidingRegion)
			)
			{
				if (intensity < sexSlapIntensity) return;
				sexSlapIntensity = intensity;
				sexSlapAS = audioSource;
				if(sexSlap == null) sexSlap = SexSlap().Start();
				
			}
			else{
				if(intensity < slapThreshold.val) return;
				// (collision.rigidbody.name+"->"+touchZone.name).Print();
				List<BodyRegion> touchedParents = touchZone.parents;
				if (touchedParents.Exists(x => x.name.Contains("Hand")) ||
				    touchedParents.Exists(x => x.name.Contains("ForeArm")))
				{
					if (selfSlap || !isSlappingOthers.val) return;
				}
				bool slappedByOtherPerson = !selfSlap && slappedByPerson;
				touchZone.Slap(intensity, touchZone, collision,slapVocalsEnabled.val && slappedByOtherPerson, slappedByOtherPerson);
			}
		}
        
        private static IEnumerator SexSlap(){
	        AudioClip clip = buttSlapLibrary.GetRandomClip();
	        yield return new WaitForSeconds(.05f);
	        float volumeFactor = sexSlapIntensity*sexSlapIntensity*sexSlapVolume.val;
	        sexSlapAS.pitch = Mathf.Lerp(.8f, 1.2f, sexSlapIntensity);
	        sexSlapAS.PlayOneShot(clip, volumeFactor);
	        // if(globalSlapMoanReactionEnabled.val) AudioManager.moanClips.PlayRandom(allowRepeat:true);
	        if(ReadMyLips.singleton.enabled) ReadMyLips.Stimulate(sexSlapIntensity*6f);
	        ReadMyLips.PlayMoan(true);
	        sexSlapIntensity = 0f;
	        sexSlap = null;
        }

        private void Exclude(string uid, bool val)
        {
	        Atom atom = SuperController.singleton.GetAtomByUid(uid);
	        if (val)
	        {
		        if(!excludedAtoms.Contains(atom))
		        {
			        excludedAtoms.Add(atom);
			        excludedInfo.val = atom.uid + "\n" + excludedInfo.val;
		        }
	        }
	        else if(excludedAtoms.Remove(atom))
	        { 
		        excludedInfo.val = string.Join("\n", excludedAtoms.Select(x => x.uid).ToArray());
	        }
        }
        
        private void AddExclusionChoice(Atom atom)
        {
	        if (excludedChooser.choices.Contains(atom.uid)) return;
	        var choices = excludedChooser.choices;
	        choices.Insert(0, atom.uid);
	        excludedChooser.choices = new List<string>(choices);
        }
        
        private void SyncAtomNames(List<string> uids)
        {
	        excludedChooser.choices = new List<string>(uids);
	        var ignoredUids = excludedAtoms.Select(x => x.uid).ToArray();
	        excludedInfo.val = string.Join("\n", ignoredUids);
        }
        
        private void ResetExcluded()
        {
	        excludedAtoms.Clear();
	        excludedInfo.val = "";
        }

        private void OnDestroy()
        {
	        foreach(TouchZone touchZone in BodyRegionMapping.touchZones.Values.ToList()){
		        touchZone.Destroy();
	        }
            AudioImporter.UnloadBundles();
            SuperController.singleton.onAtomAddedHandlers -= AddExclusionChoice;
            SuperController.singleton.onAtomUIDsChangedHandlers -= SyncAtomNames;
            ReadMyLips.Reset();
        }
    }
}